//slib.h

#ifndef _SLIB_H_
#define _SLIB_H_

#include <cmath>
#include <cstdlib>

//!Funkcje szablonowe standardowej biblioteki dla klasy CEval
namespace SLib
{

	//operatory binarne

	template<class T>
	T Add(T a,T b)
	{
		return a+b;
	}

	template<class T>
	T Sub(T a,T b)
	{
		return a-b;
	}

	template<class T>
	T Mul(T a,T b)
	{
		return a*b;
	}

	template<class T>
	T Div(T a,T b)
	{
		return a/b;
	}

	template<class T>
	T Pow(T a,T b)
	{
		return pow(a,b);
	}

	//funkcje matematyczne

	template<class T>
	T Abs(T a)
	{
		return abs(a); //a<0 ? -a:a;
	}

	template<class T>
	T Sgn(T a)
	{
		if (abs(a))
		return a/abs(a);
		else return 0;
	}

	template<class T>
	T Sin(T a)
	{
		return sin(a);
	}

	template<class T>
	T Cos(T a)
	{
		return cos(a);
	}

	template<class T>
	T Tan(T a)
	{
		return tan(a);
	}

	template<class T>
	T Ctan(T a)
	{
		return 1/tan(a);
	}

	template<class T>
	T Floor(T a)
	{
		return floor(a);
	}

	template<class T>
	T Ceil(T a)
	{
		return ceil(a);
	}

	template<class T>
	T Rnd(T a)
	{
		return (T)((float)(rand()%RAND_MAX)/(float)RAND_MAX)*a;
	}

	template<class T>
	T Ln(T a)
	{
		return log(a);
	}

	template<class T>
	T Sqrt(T a)
	{
		return sqrt(a);
	}

}

#endif //_SLIB_H_